# avi_httppolicyset – Module for setup of HTTPPolicySet Avi RESTful Object

New in version 2.4.

- Synopsis
- Requirements
- Parameters
- Notes
- Examples
- Return Values
- Status

## Synopsis

- This module is used to configure HTTPPolicySet object
- more examples at https://github.com/avinetworks/devops

## Requirements

The below requirements are needed on the host that executes this module.

- avisdk

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
api_context dictionary added in 2.5 |  | Avi API context that includes current session ID and CSRF Token. This allows user to perform single login and re-use the session.
api_version string | Default: "16.4.4" | Avi API version of to use for Avi API and objects.

avi_api_patch_op
-
added in 2.5

Choices:
- add
- replace
- delete

Patch operation to use when using avi_api_update_method as patch.

avi_api_update_method
-
added in 2.5

Choices:
- put ←
- patch

Default method for object update is HTTP PUT.
Setting to patch will override that behavior to use HTTP PATCH.

avi_credentials dictionary added in 2.5 |  | Avi Credentials dictionary which can be used in lieu of enumerating Avi Controller login details.
| api_version - | Default: "16.4.4" | Avi controller version
| controller - |  | Avi controller IP or SQDN
| csrftoken - |  | Avi controller API csrftoken to reuse existing session with session id
| password - |  | Avi controller password
| port - |  | Avi controller port
| session_id - |  | Avi controller API session id to reuse existing session with csrftoken
| tenant - | Default: "admin" | Avi controller tenant
| tenant_uuid - |  | Avi controller tenant UUID
| timeout - | Default: 300 | Avi controller request timeout
| token - |  | Avi controller API token
| username - |  | Avi controller username

avi_disable_session_cache_as_fact
boolean
added in 2.6

Choices:
- no
- yes

It disables avi session information to be cached as a fact.

cloud_config_cksum - |  | Checksum of cloud configuration for pool. Internally set by cloud connector.
controller string | Default: "" | IP address or hostname of the controller. The default value is the environment variable `AVI_CONTROLLER`.
created_by - |  | Creator name.
description - |  | User defined description for the object.
http_request_policy - |  | Http request policy for the virtual service.
http_response_policy - |  | Http response policy for the virtual service.
http_security_policy - |  | Http security policy for the virtual service.

is_internal_policy
boolean

Choices:
- no
- yes

Boolean flag to set is_internal_policy.
Default value when not specified in API or module is interpreted by Avi Controller as False.

name - / required |  | Name of the http policy set.
password string | Default: "" | Password of Avi user in Avi controller. The default value is the environment variable `AVI_PASSWORD`.

state
-

Choices:
- absent
- present ←

The state that should be applied on the entity.

tenant string | Default: "admin" | Name of tenant used for all Avi API calls and context of object.
tenant_ref - |  | It is a reference to an object of type tenant.
tenant_uuid string | Default: "" | UUID of tenant used for all Avi API calls and context of object.
url - |  | Avi controller URL of the object.
username string | Default: "" | Username used for accessing Avi controller. The default value is the environment variable `AVI_USERNAME`.
uuid - |  | Uuid of the http policy set.

## Notes

Note

- For more information on using Ansible to manage Avi Network devices see https://www.ansible.com/ansible-avi-networks.

## Examples

    - name: Create a HTTP Policy set two switch between testpool1 and testpool2
      avi_httppolicyset:
        controller: 10.10.27.90
        username: admin
        password: AviNetworks123!
        name: test-HTTP-Policy-Set
        tenant_ref: admin
        http_request_policy:
        rules:
          - index: 1
            enable: true
            name: test-test1
            match:
              path:
                match_case: INSENSITIVE
                match_str:
                  - /test1
                match_criteria: EQUALS
            switching_action:
              action: HTTP_SWITCHING_SELECT_POOL
              status_code: HTTP_LOCAL_RESPONSE_STATUS_CODE_200
              pool_ref: "/api/pool?name=testpool1"
          - index: 2
            enable: true
            name: test-test2
            match:
              path:
                match_case: INSENSITIVE
                match_str:
                  - /test2
                match_criteria: CONTAINS
            switching_action:
              action: HTTP_SWITCHING_SELECT_POOL
              status_code: HTTP_LOCAL_RESPONSE_STATUS_CODE_200
              pool_ref: "/api/pool?name=testpool2"
        is_internal_policy: false

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
obj dictionary | success, changed | HTTPPolicySet (api/httppolicyset) object

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]
- This module is maintained by the Ansible Community. [community]

### Authors

- Gaurav Rastogi (@grastogi23) <grastogi@avinetworks.com>

Hint

If you notice any issues in this documentation, you can edit this document to improve it.